<template>
  <div class="checkout-action-panel">
    <button v-if="isOpen" @click="goBack">Back</button>
    <button
      v-if="hasPartialPayment"
      @click="promptConfirmation(cancel, 'Your payments are not enough to complete the purchase. Leave anyway?')">Leave</button>
    <div v-if="prompted" class="confirmation-prompt">
      <span>{{ actionMessagePrompt }}</span>
      <button class="cancel-action" @click="reject">No</button>
      <button class="confirm-action" @click="confirm">Yes</button>
    </div>
  </div>
</template>

<script>
import {mapActions, mapGetters, mapState} from 'vuex'

const DEFAULT_MESSAGE_CONFIRMATION = 'Are you sure?'

export default {
  name: 'checkout-action-panel',
  computed: {
    ...mapState('checkout', ['checkout']),
    ...mapGetters('checkout', ['hasPartialPayment', 'isOpen']),
  },
  data() {
    return {
      prompted: false,
      action: null,
      actionMessagePrompt: DEFAULT_MESSAGE_CONFIRMATION,
    }
  },
  methods: {
    ...mapActions('checkout', ['reset']),
    ...mapActions(['cancel']),
    goBack() {
      this.cancel(this.checkout)
      this.reset()
    },
    promptConfirmation(message, action) {
      this.promptConfirmation = true
      this.action = action
      this.actionMessagePrompt = message
    },
    reject() {
      this.prompted = false
      this.action = null
      this.actionMessagePrompt = DEFAULT_MESSAGE_CONFIRMATION
    },
    confirm() {
      if (this.action) {
        this.action(this.checkout)
      }
      this.prompted = false
      this.action = null
      this.actionMessagePrompt = DEFAULT_MESSAGE_CONFIRMATION
    }
  },
}
</script>
